| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
INTupleSvc Class Referenceabstract

`#include <GaudiKernel/INTupleSvc.h>`

Inheritance diagram for INTupleSvc:
[legend]
Collaboration diagram for INTupleSvc:
[legend]

## Public Member Functions
| DeclareInterfaceID (INTupleSvc, 2, 0)
| InterfaceID. More...
virtual StatusCode | create (const CLID &typ, const std::string &title, NTuple::Tuple *&refpTuple)=0
| Create requested N tuple (Hide constructor) More...
virtual NTuple::Tuple * | book (const std::string &fullPath, const CLID &type, const std::string &title)=0
| Book Ntuple and register it with the data store. More...
virtual NTuple::Tuple * | book (const std::string &dirPath, const std::string &relPath, const CLID &type, const std::string &title)=0
| Book Ntuple and register it with the data store. More...
virtual NTuple::Tuple * | book (const std::string &dirPath, long id, const CLID &type, const std::string &title)=0
| Book Ntuple and register it with the data store. More...
virtual NTuple::Tuple * | book (DataObject *pParent, const std::string &relPath, const CLID &type, const std::string &title)=0
| Book Ntuple and register it with the data store. More...
virtual NTuple::Tuple * | book (DataObject *pParent, long id, const CLID &type, const std::string &title)=0
| Book Ntuple and register it with the data store. More...
virtual NTuple::Directory * | createDirectory (DataObject *pParent, const std::string &title)=0
| Create Ntuple directory and register it with the data store. More...
virtual NTuple::Directory * | createDirectory (DataObject *pParent, long id)=0
| Create Ntuple directory and register it with the data store. More...
virtual NTuple::Directory * | createDirectory (const std::string &dirPath, long id)=0
| Create Ntuple directory and register it with the data store. More...
virtual NTuple::Directory * | createDirectory (const std::string &dirPath, const std::string &title)=0
| Create Ntuple directory and register it with the data store. More...
virtual NTuple::Directory * | createDirectory (const std::string &fullPath)=0
| Create Ntuple directory and register it with the data store. More...
virtual NTuple::Tuple * | access (const std::string &fullPath, const std::string &filename)=0
| Access N tuple on disk. More...
virtual StatusCode | save (const std::string &fullPath)=0
| Save N tuple to disk. More...
virtual StatusCode | save (NTuple::Tuple *tuple)=0
| Save N tuple to disk. More...
virtual StatusCode | save (DataObject *pParent, const std::string &relPath)=0
| Save N tuple to disk. More...
virtual StatusCode | writeRecord (NTuple::Tuple *tuple)=0
| Write single record to N tuple. More...
virtual StatusCode | writeRecord (const std::string &fullPath)=0
| Write single record to N tuple. More...
virtual StatusCode | writeRecord (DataObject *pParent, const std::string &relPath)=0
| Write single record to N tuple. More...
virtual StatusCode | readRecord (NTuple::Tuple *tuple)=0
| Read single record from N tuple. More...
virtual StatusCode | readRecord (const std::string &fullPath)=0
| Read single record from N tuple. More...
virtual StatusCode | readRecord (DataObject *pParent, const std::string &relPath)=0
| Read single record from N tuple. More...
virtual | ~INTupleSvc ()=default
| virtual destructor More...
Public Member Functions inherited from IDataProviderSvc
| DeclareInterfaceID (IDataProviderSvc, 3, 0)
| InterfaceID. More...
virtual StatusCode | registerObject (const std::string &fullPath, DataObject *pObject)=0
| Register object with the data store. More...
virtual StatusCode | registerObject (const std::string &parentPath, const std::string &objectPath, DataObject *pObject)=0
| Register object with the data store. More...
virtual StatusCode | registerObject (const std::string &parentPath, int item, DataObject *pObject)=0
| Register object with the data store. More...
virtual StatusCode | registerObject (DataObject *parentObj, const std::string &objectPath, DataObject *pObject)=0
| Register object with the data store. More...
virtual StatusCode | registerObject (DataObject *parentObj, int item, DataObject *pObject)=0
| Register object with the data store. More...
virtual StatusCode | unregisterObject (const std::string &fullPath)=0
| Unregister object from the data store. More...
virtual StatusCode | unregisterObject (const std::string &parentPath, const std::string &objPath)=0
| Unregister object from the data store. More...
virtual StatusCode | unregisterObject (const std::string &parentPath, int item)=0
| Unregister object from the data store. More...
virtual StatusCode | unregisterObject (DataObject *pObject)=0
| Unregister object from the data store. More...
virtual StatusCode | unregisterObject (DataObject *pParent, const std::string &objPath)=0
| Unregister object from the data store. More...
virtual StatusCode | unregisterObject (DataObject *pParent, int item)=0
| Unregister object from the data store. More...
virtual StatusCode | retrieveObject (IRegistry *pDirectory, const std::string &path, DataObject *&pObject)=0
| Retrieve object identified by its directory entry. More...
virtual StatusCode | retrieveObject (const std::string &fullPath, DataObject *&pObject)=0
| Retrieve object identified by its full path from the data store. More...
virtual StatusCode | retrieveObject (const std::string &parentPath, const std::string &objectPath, DataObject *&pObject)=0
| Retrieve object from data store. More...
virtual StatusCode | retrieveObject (const std::string &parentPath, int item, DataObject *&pObject)=0
| Retrieve object from data store. More...
virtual StatusCode | retrieveObject (DataObject *parentObj, const std::string &objectPath, DataObject *&pObject)=0
| Retrieve object from data store. More...
virtual StatusCode | retrieveObject (DataObject *parentObj, int item, DataObject *&pObject)=0
| Retrieve object from data store. More...
virtual StatusCode | findObject (IRegistry *pDirectory, const std::string &path, DataObject *&pObject)=0
| Find object identified by its directory entry. More...
virtual StatusCode | findObject (const std::string &fullPath, DataObject *&pObject)=0
| Find object identified by its full path in the data store. More...
virtual StatusCode | findObject (const std::string &parentPath, const std::string &objectPath, DataObject *&pObject)=0
| Find object identified by its parent object and the path to the object relative to the parent. More...
virtual StatusCode | findObject (const std::string &parentPath, int item, DataObject *&pObject)=0
| Find object identified by its parent object and an integer identifier in the data store. More...
virtual StatusCode | findObject (DataObject *pNode, const std::string &objectPath, DataObject *&pObject)=0
| Find object identified by its parent object and the path to the object relative to the parent. More...
virtual StatusCode | findObject (DataObject *parentObj, int item, DataObject *&pObject)=0
| Find object identified by its parent object and an integer identifier in the data store. More...
virtual StatusCode | updateObject (IRegistry *pDirectory)=0
| Update object identified by its directory entry. More...
virtual StatusCode | updateObject (const std::string &fullPath)=0
| Update object identified by its full path in the data store. More...
virtual StatusCode | updateObject (DataObject *toUpdate)=0
| Update object identified by its pointer. More...
virtual StatusCode | updateObject (const std::string &parentPath, const std::string &updatePath)=0
| Update object identified by its parent's path and the path relative to the parent. More...
virtual StatusCode | updateObject (DataObject *pParent, const std::string &updatePath)=0
| Update object identified by its parent's pointer and the path relative to the parent. More...
virtual StatusCode | addPreLoadItem (const DataStoreItem &item)=0
| Add an item to the preload list. More...
virtual StatusCode | addPreLoadItem (const std::string &itemPath)=0
| Add an item to the preload list. More...
virtual StatusCode | removePreLoadItem (const DataStoreItem &item)=0
| Remove an item from the preload list. More...
virtual StatusCode | removePreLoadItem (const std::string &itemPath)=0
| Remove an item from the preload list. More...
virtual StatusCode | resetPreLoad ()=0
| Clear the preload list. More...
virtual StatusCode | preLoad ()=0
| Load all preload items of the list. More...
virtual StatusCode | linkObject (IRegistry *from, const std::string &objPath, DataObject *toObj)=0
| Add a link to another object. More...
virtual StatusCode | linkObject (const std::string &fromPath, const std::string &objPath, DataObject *toObj)=0
| Add a link to another object. More...
virtual StatusCode | linkObject (DataObject *fromObj, const std::string &objPath, DataObject *toObj)=0
| Add a link to another object. More...
virtual StatusCode | linkObject (const std::string &fullPath, DataObject *toObj)=0
| Add a link to another object. More...
virtual StatusCode | unlinkObject (IRegistry *from, const std::string &objPath)=0
| Remove a link to another object. More...
virtual StatusCode | unlinkObject (const std::string &fromPath, const std::string &objPath)=0
| Remove a link to another object. More...
virtual StatusCode | unlinkObject (DataObject *fromObj, const std::string &objPath)=0
| Remove a link to another object. More...
virtual StatusCode | unlinkObject (const std::string &fullPath)=0
| Remove a link to another object. More...
| ~IDataProviderSvc () override=default
| virtual destructor More...
Public Member Functions inherited from IInterface
virtual void * | i_cast (const InterfaceID &) const =0
| main cast function More...
virtual std::vector< std::string > | getInterfaceNames () const =0
| Returns a vector of strings containing the names of all the implemented interfaces. More...
virtual unsigned long | addRef ()=0
| Increment the reference count of Interface instance. More...
virtual unsigned long | release ()=0
| Release Interface instance. More...
virtual unsigned long | refCount () const =0
| Current reference count. More...
virtual StatusCode | queryInterface (const InterfaceID &ti, void **pp)=0
| Set the void** to the pointer to the requested interface of the instance. More...
virtual | ~IInterface ()=default
| Virtual destructor. More...

## Additional Inherited Members
Public Types inherited from IDataProviderSvc
enum | { SEPARATOR = '/' }
enum | Status { IDataProviderSvc_NO_ERROR = 1, DOUBL_OBJ_PATH, INVALID_OBJ_PATH, INVALID_ROOT, INVALID_OBJECT, INVALID_PARENT, OBJ_NOT_LOADED, NO_DATA_LOADER, INVALID_OBJ_ADDR, DIR_NOT_EMPTY, NO_MORE_LEVELS, NO_ACCESS, LAST }
| Status code definitions. More...
Public Types inherited from IInterface
enum | Status { SUCCESS = 1, NO_INTERFACE, VERSMISMATCH, LAST_ERROR }
| Return status. More...
using | iid = Gaudi::InterfaceId< IInterface, 0, 0 >
| Interface ID. More...
using | ext_iids = Gaudi::interface_list< iid >
| Extra interfaces. More...
Static Public Member Functions inherited from IInterface
static const InterfaceID & | interfaceID ()
| Return an instance of InterfaceID identifying the interface. More...

## Detailed Description

The ntuple service interface allows to:

- Export the data provider's functionality.
- Extend the functionality in order to book abstract N tuples:
  - Book COLUMN WISE N tuples.
  - Book ROW WISE N tuples.
  - Access a persistent N tuple within a file
  - Save the N tuple after filling.
  - Write individual records from to a N tuple.
  - Read individual records from an existing N tuple.
  created N tuples are automatically put onto the N tuple data store.

Author
  Markus Frank

Version
  1.0

Definition at line 37 of file INTupleSvc.h.

## Constructor & Destructor Documentation

virtual INTupleSvc::~INTupleSvc | ( |  | ) |
| virtual default

virtual destructor

## Member Function Documentation

virtual NTuple::Tuple* INTupleSvc::access | ( | const std::string & | fullPath,
|  | const std::string & | filename
| ) |  |
| pure virtual

Access N tuple on disk.

Parameters

  fullPath | Full path to the N tuple within the transient store
  filename | Name of the file the ntuple resides in.

Returns
  Status code indicating success or failure.

virtual NTuple::Tuple* INTupleSvc::book | ( | const std::string & | fullPath,
|  | const CLID & | type,
|  | const std::string & | title
| ) |  |
| pure virtual

Book Ntuple and register it with the data store.

Connects the object identified by its full path to the parent object identified by the base name of the full path.

Parameters

  fullPath | Full path to the node of the object.
  type | Class ID of the N tuple: Column or row wise.
  title | Title property of the N tuple.
  refpTuple | Reference to pointer to the N tuple to be booled and registered.

Returns
  Status code indicating success or failure.

virtual NTuple::Tuple* INTupleSvc::book | ( | const std::string & | dirPath,
|  | const std::string & | relPath,
|  | const CLID & | type,
|  | const std::string & | title
| ) |  |
| pure virtual

Book Ntuple and register it with the data store.

Connects the object identified by its relative path to the parent object identified by the base name.

Parameters

  dirPath | Path to parent node of the object.
  relPath | Relative path to the object with respect to the parent node. The relative path is the identifier of the tuple.
  title | Title property of the N tuple.
  type | Class ID of the N tuple: Column or row wise.
  refpTuple | Reference to pointer to the N tuple to be booled and registered.

Returns
  Status code indicating success or failure.

virtual NTuple::Tuple* INTupleSvc::book | ( | const std::string & | dirPath,
|  | long | id,
|  | const CLID & | type,
|  | const std::string & | title
| ) |  |
| pure virtual

Book Ntuple and register it with the data store.

Connects the object identified by an identifier to the parent object identified by the base name.

Parameters

  dirPath | Path to parent node of the object.
  id | Identifier of the tuple within the parent's directory.
  type | Class ID of the N tuple: Column or row wise.
  title | Title property of the N tuple.
  refpTuple | Reference to pointer to the N tuple to be booled and registered.

Returns
  Status code indicating success or failure.

virtual NTuple::Tuple* INTupleSvc::book | ( | DataObject * | pParent,
|  | const std::string & | relPath,
|  | const CLID & | type,
|  | const std::string & | title
| ) |  |
| pure virtual

Book Ntuple and register it with the data store.

Connects the object identified by an identifier (id) to the parent object identified by the parent's pointer.

Parameters

  pParent | Pointer to parent object.
  relPath | Relative path to the object with respect to the parent node. The relative path is the identifier of the tuple.
  type | Class ID of the N tuple: Column or row wise.
  title | Title property of the N tuple.
  refpTuple | Reference to pointer to the N tuple to be booled and registered.

Returns
  Status code indicating success or failure.

virtual NTuple::Tuple* INTupleSvc::book | ( | DataObject * | pParent,
|  | long | id,
|  | const CLID & | type,
|  | const std::string & | title
| ) |  |
| pure virtual

Book Ntuple and register it with the data store.

Connects the object identified by its relative path to the parent object identified by the parent's pointer.

Parameters

  pParent | Pointer to parent object.
  id | Identifier of the tuple within the parent's directory.
  type | Class ID of the N tuple: Column or row wise.
  title | Title property of the N tuple.

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::create | ( | const CLID & | typ,
|  | const std::string & | title,
|  | NTuple::Tuple *& | refpTuple
| ) |  |
| pure virtual

Create requested N tuple (Hide constructor)

virtual NTuple::Directory* INTupleSvc::createDirectory | ( | DataObject * | pParent,
|  | const std::string & | title
| ) |  |
| pure virtual

Create Ntuple directory and register it with the data store.

Connects the object identified by its relative path to the parent object identified by the parent's pointer.

Parameters

  pParent | Pointer to parent object.
  title | Directory identifier.

Returns
  Status code indicating success or failure.

virtual NTuple::Directory* INTupleSvc::createDirectory | ( | DataObject * | pParent,
|  | long | id
| ) |  |
| pure virtual

Create Ntuple directory and register it with the data store.

Connects the object identified by its relative path to the parent object identified by the parent's pointer.

Parameters

  pParent | Pointer to parent object.
  id | Identifier of the tuple within the parent's directory.

Returns
  Status code indicating success or failure.

virtual NTuple::Directory* INTupleSvc::createDirectory | ( | const std::string & | dirPath,
|  | long | id
| ) |  |
| pure virtual

Create Ntuple directory and register it with the data store.

Connects the object identified by its relative path to the parent object identified by the parent's pointer.

Parameters

  dirPath | Full directory path to parent
  id | Identifier of the tuple within the parent's directory.

Returns
  Status code indicating success or failure.

virtual NTuple::Directory* INTupleSvc::createDirectory | ( | const std::string & | dirPath,
|  | const std::string & | title
| ) |  |
| pure virtual

Create Ntuple directory and register it with the data store.

Connects the object identified by its path to the parent object identified by the parent's path.

Parameters

  dirPath | Full directory path to parent
  title | Directory identifier.

Returns
  Status code indicating success or failure.

virtual NTuple::Directory* INTupleSvc::createDirectory | ( | const std::string & | fullPath | ) |
| pure virtual

Create Ntuple directory and register it with the data store.

Parameters

  fullPath | Full directory path

Returns
  Status code indicating success or failure.

INTupleSvc::DeclareInterfaceID | ( | INTupleSvc | ,
|  | 2 | ,
|  | 0 |
| ) |  |

InterfaceID.

virtual StatusCode INTupleSvc::readRecord | ( | NTuple::Tuple * | tuple | ) |
| pure virtual

Read single record from N tuple.

Parameters

  tuple | Pointer to the Ntuple in memory

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::readRecord | ( | const std::string & | fullPath | ) |
| pure virtual

Read single record from N tuple.

Parameters

  fullPath | Full path to the N tuple in memory.

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::readRecord | ( | DataObject * | pParent,
|  | const std::string & | relPath
| ) |  |
| pure virtual

Read single record from N tuple.

Parameters

  pParent | Parent object of the N tuple
  relPath | Relative path to the N tuple in memory with respect to the parent object.

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::save | ( | const std::string & | fullPath | ) |
| pure virtual

Save N tuple to disk.

Must be called in order to close the ntuple file properly

Parameters

  fullPath | Full path to the N tuple in memory.

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::save | ( | NTuple::Tuple * | tuple | ) |
| pure virtual

Save N tuple to disk.

Must be called in order to close the ntuple file properly

Parameters

  tuple | Pointer to the Ntuple in memory

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::save | ( | DataObject * | pParent,
|  | const std::string & | relPath
| ) |  |
| pure virtual

Save N tuple to disk.

Must be called in order to close the ntuple file properly

Parameters

  pParent | Parent object of the N tuple
  relPath | Relative path to the N tuple in memory with respect to the parent object.

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::writeRecord | ( | NTuple::Tuple * | tuple | ) |
| pure virtual

Write single record to N tuple.

Parameters

  tuple | Pointer to the Ntuple in memory

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::writeRecord | ( | const std::string & | fullPath | ) |
| pure virtual

Write single record to N tuple.

Parameters

  fullPath | Full path to the N tuple in memory.

Returns
  Status code indicating success or failure.

virtual StatusCode INTupleSvc::writeRecord | ( | DataObject * | pParent,
|  | const std::string & | relPath
| ) |  |
| pure virtual

Write single record to N tuple.

Parameters

  pParent | Parent object of the N tuple
  relPath | Relative path to the N tuple in memory with respect to the parent object.

Returns
  Status code indicating success or failure.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/INTupleSvc.h